#!/bin/sh
#-----------------------------------------------------------------------
# File    : eval.sh
# Contents: evaluation of hamster contest programs
# Author  : Christian Borgelt
# History : 16.06.1998 file created
#-----------------------------------------------------------------------

progs="chamster"

mazes="center1 center2 drop larders leave \
       nowalls seduce serpent spiral tree \
       rand0 rand1 rand2 rand3 rand4 \
       rand5 rand6 rand7 rand8 rand9"

#-----------------------------------------------------------------------

echo maze > results.txt
for m in $mazes
do
  echo $m >> results.txt
done

#-----------------------------------------------------------------------

for p in $progs
do
  echo --- $p ---
  echo `grep maze results.txt` $p > results.tmp
  for m in $mazes
  do
    echo $m
    echo `grep $m results.txt` \
         `bin/hamster mazes/$m.maz bin/$p |
         sed -n 's/score  : //p'` >> results.tmp
  done
  mv results.tmp results.txt
done

#-----------------------------------------------------------------------

gawk '
{
  if (NR == 1) n = NF;
  printf("%-8s", $1);
  for (i = 2; i <= n; i++) {
    printf(" %8s", $i);
    if (substr($i,0,1) == "*") $i = substr($i, 2);
    if (NR == 1) sums[i]  = 0;
    else         sums[i] += int($i);
  }
  printf("\n");
}
END {
  printf("sums    ");
  for (i = 2; i <= n; i++)
    printf(" %8d", sums[i]);
  printf("\n");
}' results.txt > results.tmp
mv results.tmp results.txt

#-----------------------------------------------------------------------
